/* libguestfs generated file
 * WARNING: THIS FILE IS GENERATED BY 'src/generator.ml'.
 * ANY CHANGES YOU MAKE TO THIS FILE WILL BE LOST.
 *
 * Copyright (C) 2009 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

struct cat_rv {
  int cb_done;  /* flag to indicate callback was called */
  struct guestfs_message_header hdr;
  struct guestfs_message_error err;
  struct guestfs_cat_ret ret;
};

static void cat_cb (guestfs_h *g, void *data, XDR *xdr)
{
  struct cat_rv *rv = (struct cat_rv *) data;

  if (!xdr_guestfs_message_header (xdr, &rv->hdr)) {
    error (g, "guestfs_cat: failed to parse reply header");
    return;
  }
  if (rv->hdr.status == GUESTFS_STATUS_ERROR) {
    if (!xdr_guestfs_message_error (xdr, &rv->err)) {
      error (g, "guestfs_cat: failed to parse reply error");
      return;
    }
    goto done;
  }
  if (!xdr_guestfs_cat_ret (xdr, &rv->ret)) {
    error (g, "guestfs_cat: failed to parse reply");
    return;
  }
 done:
  rv->cb_done = 1;
  main_loop.main_loop_quit (g);
}

char *guestfs_cat (guestfs_h *g,
		const char *path)
{
  struct guestfs_cat_args args;
  struct cat_rv rv;
  int serial;

  if (g->state != READY) {
    error (g, "guestfs_cat called from the wrong state, %d != READY",
      g->state);
    return NULL;
  }

  memset (&rv, 0, sizeof rv);

  args.path = (char *) path;
  serial = dispatch (g, GUESTFS_PROC_CAT,
                     (xdrproc_t) xdr_guestfs_cat_args, (char *) &args);
  if (serial == -1)
    return NULL;

  rv.cb_done = 0;
  g->reply_cb_internal = cat_cb;
  g->reply_cb_internal_data = &rv;
  main_loop.main_loop_run (g);
  g->reply_cb_internal = NULL;
  g->reply_cb_internal_data = NULL;
  if (!rv.cb_done) {
    error (g, "guestfs_cat failed, see earlier error messages");
    return NULL;
  }

  if (check_reply_header (g, &rv.hdr, GUESTFS_PROC_CAT, serial) == -1)
    return NULL;

  if (rv.hdr.status == GUESTFS_STATUS_ERROR) {
    error (g, "%s", rv.err.error);
    return NULL;
  }

  return rv.ret.content; /* caller will free */
}

struct ll_rv {
  int cb_done;  /* flag to indicate callback was called */
  struct guestfs_message_header hdr;
  struct guestfs_message_error err;
  struct guestfs_ll_ret ret;
};

static void ll_cb (guestfs_h *g, void *data, XDR *xdr)
{
  struct ll_rv *rv = (struct ll_rv *) data;

  if (!xdr_guestfs_message_header (xdr, &rv->hdr)) {
    error (g, "guestfs_ll: failed to parse reply header");
    return;
  }
  if (rv->hdr.status == GUESTFS_STATUS_ERROR) {
    if (!xdr_guestfs_message_error (xdr, &rv->err)) {
      error (g, "guestfs_ll: failed to parse reply error");
      return;
    }
    goto done;
  }
  if (!xdr_guestfs_ll_ret (xdr, &rv->ret)) {
    error (g, "guestfs_ll: failed to parse reply");
    return;
  }
 done:
  rv->cb_done = 1;
  main_loop.main_loop_quit (g);
}

char *guestfs_ll (guestfs_h *g,
		const char *directory)
{
  struct guestfs_ll_args args;
  struct ll_rv rv;
  int serial;

  if (g->state != READY) {
    error (g, "guestfs_ll called from the wrong state, %d != READY",
      g->state);
    return NULL;
  }

  memset (&rv, 0, sizeof rv);

  args.directory = (char *) directory;
  serial = dispatch (g, GUESTFS_PROC_LL,
                     (xdrproc_t) xdr_guestfs_ll_args, (char *) &args);
  if (serial == -1)
    return NULL;

  rv.cb_done = 0;
  g->reply_cb_internal = ll_cb;
  g->reply_cb_internal_data = &rv;
  main_loop.main_loop_run (g);
  g->reply_cb_internal = NULL;
  g->reply_cb_internal_data = NULL;
  if (!rv.cb_done) {
    error (g, "guestfs_ll failed, see earlier error messages");
    return NULL;
  }

  if (check_reply_header (g, &rv.hdr, GUESTFS_PROC_LL, serial) == -1)
    return NULL;

  if (rv.hdr.status == GUESTFS_STATUS_ERROR) {
    error (g, "%s", rv.err.error);
    return NULL;
  }

  return rv.ret.listing; /* caller will free */
}

struct ls_rv {
  int cb_done;  /* flag to indicate callback was called */
  struct guestfs_message_header hdr;
  struct guestfs_message_error err;
  struct guestfs_ls_ret ret;
};

static void ls_cb (guestfs_h *g, void *data, XDR *xdr)
{
  struct ls_rv *rv = (struct ls_rv *) data;

  if (!xdr_guestfs_message_header (xdr, &rv->hdr)) {
    error (g, "guestfs_ls: failed to parse reply header");
    return;
  }
  if (rv->hdr.status == GUESTFS_STATUS_ERROR) {
    if (!xdr_guestfs_message_error (xdr, &rv->err)) {
      error (g, "guestfs_ls: failed to parse reply error");
      return;
    }
    goto done;
  }
  if (!xdr_guestfs_ls_ret (xdr, &rv->ret)) {
    error (g, "guestfs_ls: failed to parse reply");
    return;
  }
 done:
  rv->cb_done = 1;
  main_loop.main_loop_quit (g);
}

char **guestfs_ls (guestfs_h *g,
		const char *directory)
{
  struct guestfs_ls_args args;
  struct ls_rv rv;
  int serial;

  if (g->state != READY) {
    error (g, "guestfs_ls called from the wrong state, %d != READY",
      g->state);
    return NULL;
  }

  memset (&rv, 0, sizeof rv);

  args.directory = (char *) directory;
  serial = dispatch (g, GUESTFS_PROC_LS,
                     (xdrproc_t) xdr_guestfs_ls_args, (char *) &args);
  if (serial == -1)
    return NULL;

  rv.cb_done = 0;
  g->reply_cb_internal = ls_cb;
  g->reply_cb_internal_data = &rv;
  main_loop.main_loop_run (g);
  g->reply_cb_internal = NULL;
  g->reply_cb_internal_data = NULL;
  if (!rv.cb_done) {
    error (g, "guestfs_ls failed, see earlier error messages");
    return NULL;
  }

  if (check_reply_header (g, &rv.hdr, GUESTFS_PROC_LS, serial) == -1)
    return NULL;

  if (rv.hdr.status == GUESTFS_STATUS_ERROR) {
    error (g, "%s", rv.err.error);
    return NULL;
  }

  /* caller will free this, but we need to add a NULL entry */
  rv.ret.listing.listing_val = safe_realloc (g, rv.ret.listing.listing_val, rv.ret.listing.listing_len + 1);
  rv.ret.listing.listing_val[rv.ret.listing.listing_len] = NULL;
  return rv.ret.listing.listing_val;
}

struct mount_rv {
  int cb_done;  /* flag to indicate callback was called */
  struct guestfs_message_header hdr;
  struct guestfs_message_error err;
};

static void mount_cb (guestfs_h *g, void *data, XDR *xdr)
{
  struct mount_rv *rv = (struct mount_rv *) data;

  if (!xdr_guestfs_message_header (xdr, &rv->hdr)) {
    error (g, "guestfs_mount: failed to parse reply header");
    return;
  }
  if (rv->hdr.status == GUESTFS_STATUS_ERROR) {
    if (!xdr_guestfs_message_error (xdr, &rv->err)) {
      error (g, "guestfs_mount: failed to parse reply error");
      return;
    }
    goto done;
  }
 done:
  rv->cb_done = 1;
  main_loop.main_loop_quit (g);
}

int guestfs_mount (guestfs_h *g,
		const char *device,
		const char *mountpoint)
{
  struct guestfs_mount_args args;
  struct mount_rv rv;
  int serial;

  if (g->state != READY) {
    error (g, "guestfs_mount called from the wrong state, %d != READY",
      g->state);
    return -1;
  }

  memset (&rv, 0, sizeof rv);

  args.device = (char *) device;
  args.mountpoint = (char *) mountpoint;
  serial = dispatch (g, GUESTFS_PROC_MOUNT,
                     (xdrproc_t) xdr_guestfs_mount_args, (char *) &args);
  if (serial == -1)
    return -1;

  rv.cb_done = 0;
  g->reply_cb_internal = mount_cb;
  g->reply_cb_internal_data = &rv;
  main_loop.main_loop_run (g);
  g->reply_cb_internal = NULL;
  g->reply_cb_internal_data = NULL;
  if (!rv.cb_done) {
    error (g, "guestfs_mount failed, see earlier error messages");
    return -1;
  }

  if (check_reply_header (g, &rv.hdr, GUESTFS_PROC_MOUNT, serial) == -1)
    return -1;

  if (rv.hdr.status == GUESTFS_STATUS_ERROR) {
    error (g, "%s", rv.err.error);
    return -1;
  }

  return 0;
}

struct sync_rv {
  int cb_done;  /* flag to indicate callback was called */
  struct guestfs_message_header hdr;
  struct guestfs_message_error err;
};

static void sync_cb (guestfs_h *g, void *data, XDR *xdr)
{
  struct sync_rv *rv = (struct sync_rv *) data;

  if (!xdr_guestfs_message_header (xdr, &rv->hdr)) {
    error (g, "guestfs_sync: failed to parse reply header");
    return;
  }
  if (rv->hdr.status == GUESTFS_STATUS_ERROR) {
    if (!xdr_guestfs_message_error (xdr, &rv->err)) {
      error (g, "guestfs_sync: failed to parse reply error");
      return;
    }
    goto done;
  }
 done:
  rv->cb_done = 1;
  main_loop.main_loop_quit (g);
}

int guestfs_sync (guestfs_h *g)
{
  struct sync_rv rv;
  int serial;

  if (g->state != READY) {
    error (g, "guestfs_sync called from the wrong state, %d != READY",
      g->state);
    return -1;
  }

  memset (&rv, 0, sizeof rv);

  serial = dispatch (g, GUESTFS_PROC_SYNC, NULL, NULL);
  if (serial == -1)
    return -1;

  rv.cb_done = 0;
  g->reply_cb_internal = sync_cb;
  g->reply_cb_internal_data = &rv;
  main_loop.main_loop_run (g);
  g->reply_cb_internal = NULL;
  g->reply_cb_internal_data = NULL;
  if (!rv.cb_done) {
    error (g, "guestfs_sync failed, see earlier error messages");
    return -1;
  }

  if (check_reply_header (g, &rv.hdr, GUESTFS_PROC_SYNC, serial) == -1)
    return -1;

  if (rv.hdr.status == GUESTFS_STATUS_ERROR) {
    error (g, "%s", rv.err.error);
    return -1;
  }

  return 0;
}

struct touch_rv {
  int cb_done;  /* flag to indicate callback was called */
  struct guestfs_message_header hdr;
  struct guestfs_message_error err;
};

static void touch_cb (guestfs_h *g, void *data, XDR *xdr)
{
  struct touch_rv *rv = (struct touch_rv *) data;

  if (!xdr_guestfs_message_header (xdr, &rv->hdr)) {
    error (g, "guestfs_touch: failed to parse reply header");
    return;
  }
  if (rv->hdr.status == GUESTFS_STATUS_ERROR) {
    if (!xdr_guestfs_message_error (xdr, &rv->err)) {
      error (g, "guestfs_touch: failed to parse reply error");
      return;
    }
    goto done;
  }
 done:
  rv->cb_done = 1;
  main_loop.main_loop_quit (g);
}

int guestfs_touch (guestfs_h *g,
		const char *path)
{
  struct guestfs_touch_args args;
  struct touch_rv rv;
  int serial;

  if (g->state != READY) {
    error (g, "guestfs_touch called from the wrong state, %d != READY",
      g->state);
    return -1;
  }

  memset (&rv, 0, sizeof rv);

  args.path = (char *) path;
  serial = dispatch (g, GUESTFS_PROC_TOUCH,
                     (xdrproc_t) xdr_guestfs_touch_args, (char *) &args);
  if (serial == -1)
    return -1;

  rv.cb_done = 0;
  g->reply_cb_internal = touch_cb;
  g->reply_cb_internal_data = &rv;
  main_loop.main_loop_run (g);
  g->reply_cb_internal = NULL;
  g->reply_cb_internal_data = NULL;
  if (!rv.cb_done) {
    error (g, "guestfs_touch failed, see earlier error messages");
    return -1;
  }

  if (check_reply_header (g, &rv.hdr, GUESTFS_PROC_TOUCH, serial) == -1)
    return -1;

  if (rv.hdr.status == GUESTFS_STATUS_ERROR) {
    error (g, "%s", rv.err.error);
    return -1;
  }

  return 0;
}

